<template>
  <div>
    <base-breadcrumbs v-once :titles="(match) => match.meta" />

    <div class="category-wrapper bg-none">
      <div class="container-fluid p-xl-0 d-flex flex-column flex-md-row">
        <div class="grid big">
          <div class="one">
            <div class="category-image big">
              <img
                src="https://html.cwsthemes.com/liami/assets/images/resources/post-img1-1.jpg"
                alt="Denim Jacket"
              />
            </div>
          </div>
          <div class="two">
            <div class="category-title"><h2>Denim Jacket</h2></div>
          </div>
          <div class="three">
            <div class="category-description">
              <p>
                Habitasse per feugiat aliquam luctus accumsan curae, suspendisse
                aliquam taciti eros neque, aenean sit iaculis risus commodo ut
                sociosqu rhoncus potenti tristique placerat sit tempus, duis
                erat feugiat cras sociosqu porta ut praesent, fermentum donec
                convallis tellus vulputate duis nibh rhoncus phasellus dui massa
                nisl.
              </p>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div class="container">
      <div class="content">
        <base-tags :items="tags" class="tags-wrapper">
          <template #default="{ item }">
            <nuxt-link :to="'?criteria=' + item.id">{{ item.name }}</nuxt-link>
          </template>
        </base-tags>
        <div class="row">
          <div class="col-12">
            <div class="showroom-product-list row">
              <div
                v-for="(selection, idx) in selections.results"
                :key="idx"
                class="col-6 col-md-4 col-lg-3"
              >
                <product-card-mini
                  v-bind="selection"
                  :link="`/selections/${idMap.selections[selection.id]}`"
                />
              </div>
            </div>

            <base-pagination :total-pages="selections.count_pages" />
          </div>
        </div>
      </div>
      <related-content :slides="slides" />
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import { createURLSearch, mergeQuery } from '@/mixins/utils'

const ProductCardMini = () => import('@/components/product/ProductCardMini.vue')

export default {
  name: 'SelectionsPage',
  components: {
    ProductCardMini,
  },
  data() {
    return {
      tags: [],
      slides: [],
      selections: {
        count_pages: 0,
      },
    }
  },
  fetchOnServer: false,
  async fetch() {
    this.slides = (
      await this.$axios.$get('/showrooms/recommendations/')
    ).results
    this.tags = (await this.$axios.$get('/selections/criteria/')).results
  },
  head() {
    return {
      title: this.$route.meta,
    }
  },
  computed: {
    ...mapGetters({
      idMap: 'sitemap/idMap',
    }),
  },
  watch: {
    '$route.query': {
      async handler() {
        this.selections = await this.$axios.$get(
          '/selections/?' + createURLSearch(this.$route.query)
        )
      },
      immediate: true,
    },
  },
  methods: {
    mergeQuery,
    createURLSearch,
  },
}
</script>
